<?php
/*
 * (c) Logiless Inc.
 */

namespace Plugin\Logiless\E2V;

use Eccube\Entity\Product;
use LogicException;

/**
 * Class ProductE2V
 * @package Plugin\Logiless\E2V
 */
class ProductE2V extends AbstractE2V
{
    public static function convert($data)
    {
        $data = is_array($data) ? $data : array($data);

        $view = array();

        foreach ($data as $product) {
            if (!$product instanceof Product) {
                throw new LogicException();
            }

            // Product エンティティに warehouse プロパティを拡張している場合の処理
            $skuNumber = null;

            if (method_exists($product, 'getSkuNumber')) {
                $skuNumber = $product->getSkuNumber();

            } elseif (property_exists($product, 'skuNumber')) {
                $skuNumber = $product->skuNumber;
            }

            $view[] = array(
                'id' => $product->getId(),
                'name' => $product->getName(),
                'sku_number' => $skuNumber,
            );
        }

        return $view;
    }
}